function [x] = gaussel(A,b,c)
%GAUSSEL Gauss-eliminci, bemen paramterek: egyenletrendszer 
% mtrixa (A), jobboldal-vektor (b);
% c: plusz paramter, ha 1, a felhasznl kri az LU felbonts eredmnyt.
% visszatrsi rtk: megoldsvektor(x)

N = max(size(A));

% Gauss-eliminci

  for j=2:N,
       for i=j:N,
          m = A(i,j-1)/A(j-1,j-1);
          A(i,:) = A(i,:) - A(j-1,:)*m;
          b(i) = b(i) - m*b(j-1);
       end
  end

% Visszahelyettests

x = zeros(N,1);
x(N) = b(N)/A(N,N);

for j=N-1:-1:1,
    x(j) = (b(j)-A(j,j+1:N)*x(j+1:N))/A(j,j);
end


% LU felbonts
if c==1
    [n, n] = size(A);

    for k = 1:n
        if abs(A(k, k)) < sqrt(eps)
            disp(['Small pivot encountered in column ' int2str(k) '.'])
        end
        L(k, k) = 1;
        for i = k+1:n
            L(i,k) = A(i, k) / A(k, k);
            for j = k+1:n
                A(i, j) = A(i, j) - L(i, k)*A(k, j);
            end
        end
        for j = k:n
            U(k, j) = A(k, j);
        end
    end
    disp('A mtrix:')
    disp(A)
    disp('L mtrix:')
    disp(L)
    disp('U mtrix:')
    disp(U)
end
end