function gaussel2(A,b,L,M)
% Gauss-elimináció részleges föelemkiválasztással
if M==1
	tgauss(A,b)
elseif M==0	
sA=size(A);
sb=size(b);
if sA(1) ~= sA(2) | sA(1) ~= sb(1) | sb(2) ~= 1
    disp('Rossz dimenziók!')
    abort
end
n=sA(1);
A=[A,b];
if L==1
printf('0. lépés:\n');
disp(A)
end
for k=1:n-1,
    [maxe,maxindex]=max(abs(A(k:n,k)));
    if maxindex>1,     % kell sorcsere
        sorindex=maxindex+k-1;
        sor=A(sorindex,:);
        A(sorindex,:)=A(k,:);
        A(k,:)=sor;
        if L==1
        printf('A(z) %d. és %d. sor cseréje:\n',k,sorindex);
        disp(A)
        end
    end
    for i=k+1:n,
        if A(k,k)==0,
            disp('Nem hajtható végre az elimináció, főelem=0')
            if L==1
            	tgauss(A,b,1)
            else
            	tgauss(A,b,0)
            end
        end
        l=A(i,k)/A(k,k);
        for j=k+1:n+1,
            A(i,j)=A(i,j)-l*A(k,j);
        end
        %nullázás a kiiratás kedvéért:
        for j=1:k,
            A(i,j)=0;
        end        
    end
    if L==1
    printf('A(z) %d. eliminációs lépés:\n',k);
    disp(A)
    end
end
x(n)=A(n,n+1)/A(n,n);
for i=n-1:-1:1,
    x(i)=A(i,n+1);
    for j=i+1:n,
        x(i)=x(i)-A(i,j)*x(j);
    end
    x(i)=x(i)/A(i,i);
end
disp('A megoldás:')
disp(x)
end
endfunction

function tgauss(A,b,L)
%Gauss-elimináció teljes föelemkiválasztással
L=0;
sA=size(A);
sb=size(b);
if sA(1) ~= sA(2) | sA(1) ~= sb(1) | sb(2) ~= 1
    disp('Rossz dimenziók!')
    abort
end
n=sA(1);
A=[A,b];
oind=1:n;
if L==1
printf('0. lépés:\n');
disp(A)
end
for k=1:n-1,
    [maxe,maxindex]=max(abs(A(k:n,k:n)));
    sorindex=maxindex(1);
    oszlopindex=maxindex(2);
    if sorindex>k,     % kell sorcsere 
        sor=A(sorindex,:);
        A(sorindex,:)=A(k,:);
        A(k,:)=sor;
    end
    if oszlopindex>k,     % kell oszlopcsere
        oszlop=A(:,oszlopindex);
        A(:,oszlopindex)=A(:,k);
        A(:,k)=oszlop;
        oi=oind(k);
        oind(k)=oind(oszlopindex);
        oind(oszlopindex)=oi;
    end
    if L==1
    if sorindex>k & oszlopindex==k,
        printf('A(z) %d. és %d. sor cseréje:\n',k,sorindex);
    elseif  sorindex==k & oszlopindex>k,
        printf('A(z) %d. és %d. oszlop cseréje:\n',k,oszlopindex);
    elseif  sorindex>k & oszlopindex>k,
        printf('A(z) %d. és %d. sor, %d. és %d. oszlop cseréje:\n',k,sorindex,k,oszlopindex);
    end
    if sorindex>k | oszlopindex>k,
        disp(A)
    end
    end
    for i=k+1:n,
        if A(k,k)==0,
            disp('Nem hajtható végre az elimináció, föelem=0')
            abort
        end
        l=A(i,k)/A(k,k);
        for j=k+1:n+1,
            A(i,j)=A(i,j)-l*A(k,j);
        end
        %nullázás a kiiratás kedvéért:
        for j=1:k,
            A(i,j)=0;
        end        
    end
    if L==1
    printf('A(z) %d. eliminációs lépés:\n',k);
    disp(A)
    end
end
x(n)=A(n,n+1)/A(n,n);
for i=n-1:-1:1,
    x(i)=A(i,n+1);
    for j=i+1:n,
        x(i)=x(i)-A(i,j)*x(j);
    end
    x(i)=x(i)/A(i,i);
end
disp('A változók sorrendje')
disp(oind')
disp('A megoldás')
disp(x)
endfunction    