function [Q,R] = gramschmidt(A)
    %GRAMSCHMIDT Gram-Schmidt ortogonalizci
    [m,n] = size(A);
    if m~=n, fprintf('HIBA: Nem ngyzetes mtrix!'); end
    Q = zeros(n,n);
    R = zeros(n,n);
    for k=1:n
        Q(:,k) = A(:,k);
        for j=1:k-1   % 1-tl k-1-ig megy s elkszti a skalris szorzatokat
            R(j,k) = Q(:,j)'*A(:,k);
            Q(:,k) = Q(:,k) - R(j,k)*Q(:,j);
        end
        R(k,k) = norm(Q(:,k));
        Q(:,k) = Q(:,k)/R(k,k);
    end
end