function [Q,R] = gramschmidt(A)
	[m,n] = size(A);
	r=rank(A);
	if m~=n | r~=m, fprintf('Hiba, nem négyzetes a mátrix, vagy nem lineárisan független!!!\n');
	else
		Q = zeros(m,n);
		R = zeros(n,n);
		for k=1:n
			Q(:,k) = A(:,k);
			for j=1:k-1
				R(j,k) = Q(:,j)'*A(:,k);
				Q(:,k) = Q(:,k) - R(j,k)*Q(:,j);
			end
			R(k,k) = norm(Q(:,k));
			Q(:,k) = Q(:,k)/R(k,k);
		end
	end
endfunction