function x = jacobi(A, b, N)
    %Bemenet: A egyenletrendszer mtrixa, b jobboldal-vektor.
    %N az itercik szma.
    %Kezdvektor a nullvektor.
    %Kimenet: x megoldsvektor. 

    n = size(A,1);
    %A mtrix felbontsa L, U, D-re
    D = diag(diag(A));
    L = tril(-A,-1);
    U = triu(-A,1);

    %tmenetmtrix s itercikhoz hasznlt konstansvektor
    Tj = inv(D)*(L+U);
    cj = inv(D)*b;

    tol = 1e-05;
    k = 1;
    x = zeros(n,1);			%kezdvektor

    while k <= N
       x(:,k+1) = Tj*x(:,k) + cj;
       if norm(x(:,k+1)-x(:,k)) < tol
          disp('||x^(k+1) - x^(k)|| < tol elrve k iterci utn.')
          disp(k); disp('x = ');disp(x(:,k+1));
          break
       end
       k = k+1;
    end
end