function jacobi2(A,b,tol,lep)
% Jacobi-iteráció az Ax=b egyenletrendszer megoldására
% x : kezdeti vektor
% tol : tolerancia érték

sA=size(A);
sb=size(b);
if sA(1) ~= sA(2) | sA(1) ~= sb(1) | sb(2) ~= 1
    disp('Rossz dimenziók!')
    return
end
n=sA(1);
x=ones(n,1);
fprintf('0. lépés:');
disp(x)
lepes=1;
p=x+2*tol;
while abs(x-p)>tol & lepes<lep,
   p=x;
   for i=1:n,
      x(i)=b(i);
      for j=1:n,
         if j~=i,
            x(i)=x(i)-A(i,j)*p(j);
         end
      end
      x(i)=x(i)/A(i,i);
   end
   fprintf('%d. lépés:',lepes);
   disp(x)
   lepes=lepes+1;
end