function root = intfel(fname,a,b,delta,display)
% intervallum felezes modszer.
%milyen pontossg, hny lps, klnbz eljelek
%hibakorlt hibabecsls, hibazenet ha rossz intervallum
%input: fname is a string that names the function f(x)
% a and b define an interval [a,b]
% delta is the tolerance
% display = 1 if step-by-step display is desired,
% = 0 otherwise
%output: root is the computed root of f(x)=0
%
fa = feval(fname,a);               %elojelellenorzes
fb = feval(fname,b);
if sign(fa)*sign(fb) > 0
    disp('megegyezik az elojeluk')
    return
end



if fa == 0,             %ha fv A pontban 0 akkor gyok a
    root = a;
    return
end

if fb == 0              %ha fv B pontban 0 akkor gyok a
    root = b;
    return
end

c = (a+b)/2;                %felveszunk 1 pontot a b intevallumon
fc = feval(fname,c);        %kiertekeljuk erre a pontra a fuggvenyt
e_bound = abs(b-a)/2;       %vesszuk az intervallum hosszanak a felet
if display,                 %ha kertunk kimutatast itt kiiratjuk az intervallumot s a hibakorlatot
disp(' ');
disp(' a b c f(c) hibakorlat');
disp(' ');
disp([a b c fc e_bound])
end



while e_bound > delta      %amig a kisebb az engedlyezett hibakorlat
    if fc == 0,                  
    root = c;
    return
    end


    if sign(fa)*sign(fc) < 0 % gyok van [a,c] ben.
        b = c;
        fb = fc;
    else % gyok van  [c,b] ben.
        a = c;
        fa = fc;
    end

    c = (a+b)/2;
    fc = feval(fname,c);
    e_bound = e_bound/2;
    if display, disp([a b c fc e_bound]), end
end
root = c;